/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface IdentifyUserRequestBodyGroupsItem {
    identifier: string;
    properties: Record<string, unknown>;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

interface IdentifyBatchRequestBodyItem {
    identifier: string;
    properties: Record<string, unknown>;
    groups?: IdentifyBatchRequestBodyItemGroupsItem[];
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface IdentifyBatchRequestBodyItemGroupsItem {
    identifier: string;
    properties: Record<string, unknown>;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface BadRequestErrorResponseBody {
    code: "invalid_request_error";
    details: string;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare type IdentifyBatchRequestBody = IdentifyBatchRequestBodyItem[];

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface IdentifyBatchResponseBody {
    count: number;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
declare type IdentifyRequestBody = Record<string, unknown>;

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface IdentifyRequestParams {
    identifier: string;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare type IdentifySegmentRequestBody = IdentifySegmentRequestBody.Identify | IdentifySegmentRequestBody.Group;
declare namespace IdentifySegmentRequestBody {
    interface Identify extends IdentifySegmentRequestBodyIdentify {
        type: "identify";
    }
    interface Group extends IdentifySegmentRequestBodyGroup {
        type: "group";
    }
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface IdentifySegmentRequestBodyIdentify {
    userId: string;
    traits: Record<string, unknown>;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface IdentifySegmentRequestBodyGroup {
    groupId: string;
    userId: string;
    traits: Record<string, unknown>;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface IdentifySegmentResponseBody {
    count: number;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface InternalServerErrorResponseBody {
    code: "internal_server_error";
    details: string;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface NotFoundErrorResponseBody {
    code: "not_found_error";
    details: string;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface SegmentCommon {
    userId: string;
    traits: Record<string, unknown>;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface SegmentGroup {
    type: "group";
    groupId: string;
    userId: string;
    traits: Record<string, unknown>;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface SegmentIdentify {
    type: "identify";
    userId: string;
    traits: Record<string, unknown>;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface TimeoutErrorResponseBody {
    code: "internal_server_error";
    details: string;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface UnauthorizedErrorResponseBody {
    code: "unauthorized_error";
    details: string;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
declare class DoptApiError extends Error {
    readonly statusCode?: number;
    readonly body?: unknown;
    constructor({ message, statusCode, body }: {
        message?: string;
        statusCode?: number;
        body?: unknown;
    });
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
declare class DoptApiTimeoutError extends Error {
    constructor();
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare class BadRequestError extends DoptApiError {
    constructor(body: BadRequestErrorResponseBody);
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare class UnauthorizedError extends DoptApiError {
    constructor(body: UnauthorizedErrorResponseBody);
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare class InternalServerError extends DoptApiError {
    constructor(body: InternalServerErrorResponseBody);
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

interface IdentifyUserRequestBody {
    identifier: string;
    properties: Record<string, unknown>;
    groups?: IdentifyUserRequestBodyGroupsItem[];
}

type index_d$2_IdentifyUserRequestBody = IdentifyUserRequestBody;
declare namespace index_d$2 {
  export {
    index_d$2_IdentifyUserRequestBody as IdentifyUserRequestBody,
  };
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface IdentifyGroupRequestBody {
    identifier: string;
    properties: Record<string, unknown>;
}

type index_d$1_IdentifyGroupRequestBody = IdentifyGroupRequestBody;
declare namespace index_d$1 {
  export {
    index_d$1_IdentifyGroupRequestBody as IdentifyGroupRequestBody,
  };
}

type index_d_IdentifyUserRequestBodyGroupsItem = IdentifyUserRequestBodyGroupsItem;
type index_d_IdentifyBatchRequestBodyItem = IdentifyBatchRequestBodyItem;
type index_d_IdentifyBatchRequestBodyItemGroupsItem = IdentifyBatchRequestBodyItemGroupsItem;
type index_d_BadRequestErrorResponseBody = BadRequestErrorResponseBody;
type index_d_IdentifyBatchRequestBody = IdentifyBatchRequestBody;
type index_d_IdentifyBatchResponseBody = IdentifyBatchResponseBody;
type index_d_IdentifyRequestBody = IdentifyRequestBody;
type index_d_IdentifyRequestParams = IdentifyRequestParams;
declare const index_d_IdentifySegmentRequestBody: typeof IdentifySegmentRequestBody;
type index_d_IdentifySegmentRequestBodyIdentify = IdentifySegmentRequestBodyIdentify;
type index_d_IdentifySegmentRequestBodyGroup = IdentifySegmentRequestBodyGroup;
type index_d_IdentifySegmentResponseBody = IdentifySegmentResponseBody;
type index_d_InternalServerErrorResponseBody = InternalServerErrorResponseBody;
type index_d_NotFoundErrorResponseBody = NotFoundErrorResponseBody;
type index_d_SegmentCommon = SegmentCommon;
type index_d_SegmentGroup = SegmentGroup;
type index_d_SegmentIdentify = SegmentIdentify;
type index_d_TimeoutErrorResponseBody = TimeoutErrorResponseBody;
type index_d_UnauthorizedErrorResponseBody = UnauthorizedErrorResponseBody;
type index_d_BadRequestError = BadRequestError;
declare const index_d_BadRequestError: typeof BadRequestError;
type index_d_UnauthorizedError = UnauthorizedError;
declare const index_d_UnauthorizedError: typeof UnauthorizedError;
type index_d_InternalServerError = InternalServerError;
declare const index_d_InternalServerError: typeof InternalServerError;
type index_d_IdentifyUserRequestBody = IdentifyUserRequestBody;
type index_d_IdentifyGroupRequestBody = IdentifyGroupRequestBody;
declare namespace index_d {
  export {
    index_d_IdentifyUserRequestBodyGroupsItem as IdentifyUserRequestBodyGroupsItem,
    index_d_IdentifyBatchRequestBodyItem as IdentifyBatchRequestBodyItem,
    index_d_IdentifyBatchRequestBodyItemGroupsItem as IdentifyBatchRequestBodyItemGroupsItem,
    index_d_BadRequestErrorResponseBody as BadRequestErrorResponseBody,
    index_d_IdentifyBatchRequestBody as IdentifyBatchRequestBody,
    index_d_IdentifyBatchResponseBody as IdentifyBatchResponseBody,
    index_d_IdentifyRequestBody as IdentifyRequestBody,
    index_d_IdentifyRequestParams as IdentifyRequestParams,
    index_d_IdentifySegmentRequestBody as IdentifySegmentRequestBody,
    index_d_IdentifySegmentRequestBodyIdentify as IdentifySegmentRequestBodyIdentify,
    index_d_IdentifySegmentRequestBodyGroup as IdentifySegmentRequestBodyGroup,
    index_d_IdentifySegmentResponseBody as IdentifySegmentResponseBody,
    index_d_InternalServerErrorResponseBody as InternalServerErrorResponseBody,
    index_d_NotFoundErrorResponseBody as NotFoundErrorResponseBody,
    index_d_SegmentCommon as SegmentCommon,
    index_d_SegmentGroup as SegmentGroup,
    index_d_SegmentIdentify as SegmentIdentify,
    index_d_TimeoutErrorResponseBody as TimeoutErrorResponseBody,
    index_d_UnauthorizedErrorResponseBody as UnauthorizedErrorResponseBody,
    index_d_BadRequestError as BadRequestError,
    index_d_UnauthorizedError as UnauthorizedError,
    index_d_InternalServerError as InternalServerError,
    index_d$2 as users,
    index_d$1 as groups,
    index_d_IdentifyUserRequestBody as IdentifyUserRequestBody,
    index_d_IdentifyGroupRequestBody as IdentifyGroupRequestBody,
  };
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
declare const DoptApiEnvironment: {
    readonly Default: "https://users.dopt.com";
};
declare type DoptApiEnvironment = typeof DoptApiEnvironment.Default;

declare type Supplier<T> = T | Promise<T> | (() => T | Promise<T>);
declare const Supplier: {
    get: <T>(supplier: Supplier<T>) => Promise<T>;
};

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare namespace Users {
    interface Options {
        environment?: Supplier<DoptApiEnvironment | string>;
        apiKey: Supplier<string>;
    }
    interface RequestOptions {
        timeoutInSeconds?: number;
    }
}
declare class Users {
    protected readonly _options: Users.Options;
    constructor(_options: Users.Options);
    /**
     * Identifies a user to the Dopt user API
     * @throws {@link DoptApi.BadRequestError}
     * @throws {@link DoptApi.UnauthorizedError}
     * @throws {@link DoptApi.InternalServerError}
     */
    identifyUser(request: IdentifyUserRequestBody, requestOptions?: Users.RequestOptions): Promise<void>;
    /**
     * Identifies users to the Dopt users API (limited to 100 users per request)
     * @throws {@link DoptApi.BadRequestError}
     * @throws {@link DoptApi.UnauthorizedError}
     * @throws {@link DoptApi.InternalServerError}
     */
    identifyUsers(request: IdentifyBatchRequestBodyItem[], requestOptions?: Users.RequestOptions): Promise<IdentifyBatchResponseBody>;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare namespace Groups {
    interface Options {
        environment?: Supplier<DoptApiEnvironment | string>;
        apiKey: Supplier<string>;
    }
    interface RequestOptions {
        timeoutInSeconds?: number;
    }
}
declare class Groups {
    protected readonly _options: Groups.Options;
    constructor(_options: Groups.Options);
    /**
     * Identifies a group to the Dopt user API
     * @throws {@link DoptApi.BadRequestError}
     * @throws {@link DoptApi.UnauthorizedError}
     * @throws {@link DoptApi.InternalServerError}
     */
    identifyGroup(request: IdentifyGroupRequestBody, requestOptions?: Groups.RequestOptions): Promise<void>;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare namespace DoptApiClient {
    interface Options {
        environment?: Supplier<DoptApiEnvironment | string>;
        apiKey: Supplier<string>;
    }
    interface RequestOptions {
        timeoutInSeconds?: number;
    }
}
declare class DoptApiClient {
    protected readonly _options: DoptApiClient.Options;
    constructor(_options: DoptApiClient.Options);
    protected _users: Users | undefined;
    get users(): Users;
    protected _groups: Groups | undefined;
    get groups(): Groups;
}

export { index_d as DoptApi, DoptApiClient, DoptApiEnvironment, DoptApiError, DoptApiTimeoutError };
